// Fill out your copyright notice in the Description page of Project Settings.
#include "TankPlayerController.h"
#include "Tank.h"


void ATankPlayerController::Tick(float DeltaTime) {
	Super::Tick(DeltaTime);
	AimAtCrosshair();
}

void  ATankPlayerController::BeginPlay() {
	Super::BeginPlay();
	auto PossessedTank = GetControlledTank()->GetName();
}

ATank* ATankPlayerController::GetControlledTank() const {
	return Cast<ATank>(GetPawn());
}

void  ATankPlayerController::AimAtCrosshair()
{
	if (!GetControlledTank()) { return; }
	FVector OutHitLocation;
	if (GetSightRayHitLocation(OutHitLocation)) {
		GetControlledTank()->AimingAt(OutHitLocation);
	}
	
}

bool ATankPlayerController::GetSightRayHitLocation(FVector &OutHitLocation) const
{
	int32 ViewportSizeX, ViewportSizeY;
	GetViewportSize(ViewportSizeX, ViewportSizeY);

	auto ScreenLocation = FVector2D(ViewportSizeX * CrosshairX, ViewportSizeY * CrosshairY);
	FVector  WorldLocation, WorldDirection;
	if (GetLookDirection(ScreenLocation.X,ScreenLocation.Y,WorldLocation, WorldDirection)) {
		GetLookDirectionHitLocation(WorldDirection, OutHitLocation);

	}
	return true;
}

bool ATankPlayerController::GetLookDirection(float screenx, float screeny, FVector &CameraWorldLocation, FVector &WorldDirection)const {
	DeprojectScreenPositionToWorld(screenx, screeny, CameraWorldLocation, WorldDirection);
	return true;
}

bool ATankPlayerController::GetLookDirectionHitLocation(FVector LookDirection,FVector &HitLocation) const {
	FHitResult HitResult;
	auto StartLocation = PlayerCameraManager->GetCameraLocation();
	auto EndLocation = StartLocation + (LookDirection*LineTraceRange);
	if (GetWorld()->LineTraceSingleByChannel(
		HitResult,
		StartLocation,
		EndLocation,
		ECollisionChannel::ECC_Visibility
		)) {
		HitLocation = HitResult.Location;
		
		return true;
	}
	HitLocation = FVector(0);
	return false;
}