// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "Engine/World.h"
#include "CoreMinimal.h"
#include "GameFramework/PlayerController.h"
#include "TankPlayerController.generated.h"

class ATank;


UCLASS()
class BATTLETANK_API ATankPlayerController : public APlayerController
{
	GENERATED_BODY()
	//override func
	virtual void BeginPlay() override;
	virtual void Tick(float DeltaTime) override;

	//data member
	UPROPERTY(EditAnyWhere)
	float CrosshairX = 0.5f;
	UPROPERTY(EditAnyWhere)
	float CrosshairY = 0.3333f;
	UPROPERTY(EditAnyWhere)
	float LineTraceRange = 1000000.0f;

	//member func
	ATank* GetControlledTank() const;
	void AimAtCrosshair();
	bool GetSightRayHitLocation(FVector & OutHitLocation) const;
	bool GetLookDirection(float screenx, float screeny, FVector &CameraWorldLocation, FVector &WorldDirection)const;
	bool GetLookDirectionHitLocation(FVector LookDirection, FVector & HitLoaction) const;
};
